]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame - builder.sh
- better messages, fix indent
[packages/rpm-build-tools.git] / builder.sh
CommitLineData
1d7abbe3 1#!/bin/ksh
cd445739 2# -----------
cd445739 3# Exit codes:
2a5f078d 4# 0 - succesful
5# 1 - help displayed
6# 2 - no spec file name in cmdl parameters
7# 3 - spec file not stored in repo
8# 4 - some source, patch or icon files not stored in repo
9# 5 - package build failed
10# 6 - spec file with errors
11# 7 - wrong source in /etc/poldek.conf
12# 8 - Failed installing buildrequirements and subrequirements
13# 9 - Requested tag already exist
14# 10 - Refused to build fractional release
15# 100 - Unknown error (should not happen)
cd445739
AM
16
17# Notes (todo):
f7b91886 18# - builder -u fetches current version first (well that's okay, how you compare versions if you have no old spec?)
cd445739 19# - when Icon: field is present, -5 and -a5 doesn't work
f3ada241 20# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
931a4acf 21
d43959a2
ER
22RCSID='$Id$'
23r=${RCSID#* * }
24rev=${r%% *}
25VERSION="v0.18/$rev"
26VERSIONSTRING="\
c9acaed9 27Build package utility from PLD Linux CVS repository
d43959a2
ER
28$VERSION (C) 1999-2007 Free Penguins".
29
d6a77ddb 30PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
b03f053b 31
cd445739 32COMMAND="build"
64ea5308 33TARGET=""
cd445739 34
bde1c404 35SPECFILE=""
d287305c 36BE_VERBOSE=""
4003ad8c 37QUIET=""
cd445739
AM
38CLEAN=""
39DEBUG=""
40NOURLS=""
41NOCVS=""
42NOCVSSPEC=""
43NODIST=""
47761337 44NOINIT=""
cd445739 45UPDATE=""
cd445739
AM
46ADD5=""
47NO5=""
48ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
c8f50498 49CVSROOT=""
cd445739
AM
50
51# It can be used i.e. in log file naming.
52# See LOGFILE example.
53DATE=`date +%Y-%m-%d_%H-%M-%S`
54
55# Example: LOGFILE='../log.$PACKAGE_NAME'
56# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
57# Yes, you can use variable name! Note _single_ quotes!
58LOGFILE=''
59
60LOGDIR=""
61LOGDIROK=""
62LOGDIRFAIL=""
63LASTLOG_FILE=""
64
65CHMOD="no"
66CHMOD_MODE="0444"
67RPMOPTS=""
d1c5a9a7 68RPMBUILDOPTS=""
cd445739
AM
69BCOND=""
70GROUP_BCONDS="no"
947025e5 71CVSIGNORE_DF="no"
d287305c 72
73PATCHES=""
74SOURCES=""
cd445739 75ICONS=""
d287305c 76PACKAGE_RELEASE=""
77PACKAGE_VERSION=""
78PACKAGE_NAME=""
cd445739
AM
79PROTOCOL="ftp"
80WGET_RETRIES=${MAX_WGET_RETRIES:-0}
81CVS_RETRIES=${MAX_CVS_RETRIES:-1000}
82
83CVSTAG=""
84RES_FILE=""
39dcc7de 85CVS_FORCE=""
cd445739
AM
86
87CVS_SERVER="cvs.pld-linux.org"
88DISTFILES_SERVER="://distfiles.pld-linux.org"
d4730dae 89ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
cd445739 90
36d03934 91DEF_NICE_LEVEL=19
86aafdbe 92SCHEDTOOL="auto"
cd445739
AM
93
94FAIL_IF_NO_SOURCES="yes"
95
18e5347d
ER
96# let get_files skip over files which are present to get those damn files fetched
97SKIP_EXISTING_FILES="no"
98
975d7b23 99TRY_UPGRADE=""
257af81b
ER
100# should the specfile be restored if upgrade failed?
101REVERT_BROKEN_UPGRADE="yes"
102
ab4a2b6e 103if [ -x /usr/bin/rpm-getdeps ]; then
ce40491a 104 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
ab4a2b6e 105else
ce40491a 106 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
ab4a2b6e
ER
107fi
108
cd445739
AM
109# Here we load saved user environment used to
110# predefine options set above, or passed to builder
111# in command line.
112# This one reads global system environment settings:
113if [ -f ~/etc/builderrc ]; then
114 . ~/etc/builderrc
115fi
116# And this one cascades settings using user personal
117# builder settings.
118# Example of ~/.builderrc:
119#
120#UPDATE_POLDEK_INDEXES="yes"
121#FETCH_BUILD_REQUIRES="yes"
122#REMOVE_BUILD_REQUIRES="force"
123#GROUP_BCONDS="yes"
124#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
982e358c 125#TITLECHANGE=no
cd445739 126#
a83e5405 127SU_SUDO=""
cd445739
AM
128if [ -n "$HOME_ETC" ]; then
129 USER_CFG="$HOME_ETC/.builderrc"
130else
131 USER_CFG=~/.builderrc
132fi
133
134[ -f "$USER_CFG" ] && . "$USER_CFG"
135
86aafdbe
ER
136if [ "$SCHEDTOOL" = "auto" ]; then
137 if [ -x /usr/bin/schedtool ] && schedtool -B -e echo >/dev/null; then
138 SCHEDTOOL="schedtool -B -e"
139 else
140 SCHEDTOOL="no"
141 fi
142fi
143
ca2e6c31 144if [ -n "$USE_PROZILLA" ]; then
7e365483
KK
145 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
146 GETURI2="$GETURI"
147 OUTFILEOPT="-O"
ca2e6c31 148elif [ -n "$USE_AXEL" ]; then
cede92b3 149 GETURI="axel -a $AXEL_OPTS"
7e365483
KK
150 GETURI2="$GETURI"
151 OUTFILEOPT="-o"
ca2e6c31 152else
5700ee32
ER
153 wget --help 2>&1 | grep -q -- ' --no-check-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
154 wget --help 2>&1 | grep -q -- ' --inet ' && WGET_OPTS="$WGET_OPTS --inet"
155 wget --help 2>&1 | grep -q -- ' --retry-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
6f9a5d76 156
7e365483
KK
157 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
158 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
159 OUTFILEOPT="-O"
2bc5451f 160fi
11468b23 161
11468b23
AM
162GETLOCAL="cp -a"
163
164if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
165 RPM="rpm"
166 RPMBUILD="rpm"
167else
168 RPM="rpm"
169 RPMBUILD="rpmbuild"
170fi
171
172POLDEK_INDEX_DIR="`$RPM --eval %_rpmdir`/"
a83e5405 173POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
11468b23 174
cd445739
AM
175run_poldek()
176{
177 RES_FILE=~/tmp/poldek-exit-status.$RANDOM
178 if [ -n "$LOGFILE" ]; then
179 LOG=`eval echo $LOGFILE`
180 if [ -n "$LASTLOG_FILE" ]; then
181 echo "LASTLOG=$LOG" > $LASTLOG_FILE
182 fi
86aafdbe 183 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
cd445739
AM
184 return $exit_pldk
185 else
86aafdbe 186 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
cd445739
AM
187 return `cat ${RES_FILE}`
188 rm -rf ${RES_FILE}
189 fi
190}
191
cd445739
AM
192#---------------------------------------------
193# functions
da946cd6 194
5a491465 195usage()
196{
cd445739
AM
197 if [ -n "$DEBUG" ]; then set -xv; fi
198 echo "\
d43959a2 199Usage: builder [-D|--debug] [-V|--version] [--short-version] [-a|--as_anon] [-b|-ba|--build]
6594293d 200[-bb|--build-binary] [-bs|--build-source] [-bc] [-bi] [-bl] [-u|--try-upgrade]
4efa0b98 201[{-cf|--cvs-force}] [{-B|--branch} <branch>] [{-d|--cvsroot} <cvsroot>]
19dc5591 202[-g|--get] [-h|--help] [--http] [{-l|--logtofile} <logfile>] [-m|--mr-proper]
203[-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T|--tag <cvstag>]
a7b2951c 204[-Tvs|--tag-version-stable] [-Ts|--tag-stable] [-Tv|--tag-version]
cd445739 205[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}]
6594293d 206[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--short-circuit]
3009b80d 207[--show-bconds] [--with/--without <feature>] [--define <macro> <value>]
6594293d 208<package>[.spec][:cvstag]
2a5f078d 209
cd445739
AM
210-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
211-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
212-n5, --no-md5 - ignore md5 comments in spec
9243e80b
ER
213-D, --debug - enable builder script debugging mode,
214-debug - produce rpm debug package (same as --opts -debug)
d43959a2
ER
215-V, --version - output builder version string
216--short-version - output builder short version
cd445739
AM
217-a, --as_anon - get files via pserver as cvs@$CVS_SERVER,
218-b, -ba, --build - get all files from CVS repo or HTTP/FTP and build package
219 from <package>.spec,
220-bb, --build-binary - get all files from CVS repo or HTTP/FTP and build binary
221 only package from <package>.spec,
c56807e0 222-bp, --build-prep - execute the %prep phase of <package>.spec,
6594293d
AG
223-bc - execute the %build phase of <package>.spec,
224-bi - execute the %install phase of <package>.spec
225-bl - execute the %files phase of <package>.spec
cd445739
AM
226-bs, --build-source - get all files from CVS repo or HTTP/FTP and only pack
227 them into src.rpm,
6594293d 228--short-circuit - short-circuit build
cd445739
AM
229-B, --branch - add branch
230-c, --clean - clean all temporarily created files (in BUILD, SOURCES,
231 SPECS and \$RPM_BUILD_ROOT),
39dcc7de 232-cf, --cvs-force - use -F when tagging (useful when moving branches)
2a5f078d 233-d <cvsroot>, --cvsroot <cvsroot>
cd445739
AM
234 - setup \$CVSROOT,
235--define <macro> <value>
236 - define a macro <macro> with value <value>,
237--nodeps - rpm won't check any dependences
238-g, --get - get <package>.spec and all related files from CVS repo
239 or HTTP/FTP,
240-h, --help - this message,
241--http - use http instead of ftp,
242-l <logfile>, --logtofile <logfile>
243 - log all to file,
244-m, --mr-proper - only remove all files related to spec file and all work
245 resources,
246-nc, --no-cvs - don't download sources from CVS, if source URL is given,
247-ncs, --no-cvs-specs
248 - don't check specs in CVS
249-nd, --no-distfiles - don't download from distfiles
250-nm, --no-mirrors - don't download from mirror, if source URL is given,
251-nu, --no-urls - don't try to download from FTP/HTTP location,
252-ns, --no-srcs - don't download Sources
253-ns0, --no-source0 - don't download Source0
254-nn, --no-net - don't download anything from the net
b572253e 255--no-init - don't initialize builder paths (SPECS and SOURCES)
18e5347d
ER
256-ske,
257--skip-existing-files - skip existing files in get_files
cd445739
AM
258--opts <rpm opts> - additional options for rpm
259-q, --quiet - be quiet,
260--date yyyy-mm-dd - build package using resources from specified CVS date,
261-r <cvstag>, --cvstag <cvstag>
262 - build package using resources from specified CVS tag,
5323fffd 263-A - build package using CVS resources as any sticky tags/date/kopts being reset.
cd445739
AM
264-R, --fetch-build-requires
265 - fetch what is BuildRequired,
266-RB, --remove-build-requires
267 - remove all you fetched with -R or --fetch-build-requires
268 remember, this option requires confirmation,
269-FRB, --force-remove-build-requires
270 - remove all you fetched with -R or --fetch-build-requires
271 remember, this option works without confirmation,
06541433
JR
272-sd, --source-distfiles - list sources available from distfiles (intended for offline
273 operations; does not work when Icon field is present
274 but icon file is absent),
275-sdp, --source-distfiles-paths - list sources available from distfiles -
276 paths relative to distfiles directory (intended for offline
277 operations; does not work when Icon field is present
278 but icon file is absent),
a7eefc54 279-sf, --source-files - list sources - bare filenames (intended for offline
280 operations; does not work when Icon field is present
3621e588 281 but icon file is absent),
a7eefc54 282-sp, --source-paths - list sources - filenames with full local paths (intended for
283 offline operations; does not work when Icon field is present
3621e588 284 but icon file is absent),
2dddf439
ER
285-su, --source-urls - list urls - urls to sources and patches
286 intended for copying urls with spec with lots of macros in urls
cd445739
AM
287-T <cvstag> , --tag <cvstag>
288 - add cvs tag <cvstag> for files,
289-Tvs, --tag-version-stable
094bd95b 290 - add cvs tags STABLE and NAME-VERSION-RELEASE for files,
cd445739
AM
291-Ts, --tag-stable
292 - add cvs tag STABLE for files,
cd445739 293-Tv, --tag-version
1691a37b 294 - add cvs tag NAME-VERSION-RELEASE for files,
cd445739
AM
295-Tp, --tag-prefix <prefix>
296 - add <prefix> to NAME-VERSION-RELEASE tags,
297-tt, --test-tag <prefix>
298 - fail if tag is already present,
50321881
JK
299-ir, --integer-release-only
300 - allow only integer and snapshot releases
cd445739
AM
301-v, --verbose - be verbose,
302-u, --try-upgrade - check version, and try to upgrade package
303-un, --try-upgrade-with-float-version
304 - as above, but allow float version
deccc50e 305-U, --update - refetch sources, don't use distfiles, and update md5 comments
cd445739
AM
306-Upi, --update-poldek-indexes
307 - refresh or make poldek package index files.
c890b916 308-np, --nopatch <patchnumber>
bed98670 309 - don't apply <patchnumber>
dfe2cb9a
MK
310--show-bconds - show available conditional builds, which can be used
311 - with --with and/or --without switches.
9b78be50
ER
312--show-bcond-args - show active bconds, from ~/.bcondrc. this is used by
313 ./repackage.sh script. in other words, the output is
314 parseable by scripts.
cd445739
AM
315--with/--without <feature>
316 - conditional build package depending on %_with_<feature>/
317 %_without_<feature> macro switch. You may now use
318 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
319 constructions. Set GROUP_BCONDS to yes to make use of it.
6dd19291 320--target <platform>, --target=<platform>
3621e588
ER
321 - build for platform <platform>.
322--init-rpm-dir - initialize ~/rpm directory structure
5a491465 323"
324}
325
c890b916 326update_shell_title() {
a0d6396b 327 [ -t 1 ] || return
0b65d15e
ER
328 local len=${COLUMNS:-80}
329 local msg=$(echo "$*" | cut -c-$len)
330
e225de91
ER
331 if [ -n "$BE_VERBOSE" ]; then
332 echo >&2 "$(date +%s.%N) $*"
333 fi
334
982e358c 335 if [ "x$TITLECHANGE" == "xyes" -o "x$TITLECHANGE" == "x" ]; then
138bbc98
ER
336 local pkg
337 if [ -n "$PACKAGE_NAME" ]; then
338 pkg=${PACKAGE_NAME}-${PACKAGE_VERSION}-${PACKAGE_RELEASE}
339 else
340 pkg=${SPECFILE}
341 fi
342
343 msg="$pkg: ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
10c1e115 344 msg="$(echo $msg | tr -d '\n\r')"
982e358c
MP
345 case "$TERM" in
346 cygwin|xterm*)
347 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
348 ;;
349 screen*)
350 echo >&2 -ne "\033]0;$msg\007"
351 ;;
352 esac
353 fi
c890b916
ER
354}
355
7e40520f
ER
356# set TARGET from BuildArch: from SPECFILE
357set_spec_target() {
ce40491a
ER
358 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
359 tmp=$(awk '/^BuildArch:/ { print $NF}' $SPECFILE)
360 if [ "$tmp" ]; then
f9109a96 361 target_platform=$(rpm -E '%{_target_vendor}-%{_target_os}%{?_gnu}')
7e40520f
ER
362 TARGET="$tmp"
363 case "$RPMBUILD" in
364 "rpmbuild")
f9109a96 365 TARGET_SWITCH="--target ${TARGET}-${target_platform}" ;;
7e40520f 366 "rpm")
ce40491a 367 TARGET_SWITCH="--target=$TARGET" ;;
7e40520f 368 esac
ce40491a
ER
369 fi
370 fi
7e40520f
ER
371}
372
ace3fd80
ER
373# runs rpm with minimal macroset
374minirpm() {
fa4bf1df 375 # we reset macros not to contain macros.build as all the %() macros are
559d511f 376 # executed here, while none of them are actually needed.
559d511f 377 # at the time of this writing macros.build + macros contained 70 "%(...)" macros.
13c3c336 378 safe_macrofiles=$(rpm --showrc | awk -F: '/^macrofiles/ { gsub(/^macrofiles[ \t]+:/, "", $0); gsub(/:.*macros.build:/, ":", $0); print $0 } ')
ace3fd80
ER
379
380 # TODO: move these to /usr/lib/rpm/macros
36433112 381 cat > .builder-rpmmacros <<'EOF'
5b5e5f7f 382%x8664 x86_64 amd64 ia32e
f78a0bb7 383%alt_kernel %{nil}
384%_alt_kernel %{nil}
fb198857
ER
385%requires_releq_kernel_up %{nil}
386%requires_releq_kernel_smp %{nil}
6b8134e3 387%requires_releq() %{nil}
bb01dee9 388%pyrequires_eq() %{nil}
559d511f 389%requires_eq() %{nil}
c13be3d1 390%requires_eq_to() %{nil}
fb198857
ER
391%releq_kernel_up ERROR
392%releq_kernel_smp ERROR
74d9fd14 393%kgcc_package ERROR
237bd3f1 394%_fontsdir ERROR
7141278d 395%ruby_version ERROR
396%ruby_ver_requires_eq() %{nil}
397%ruby_mod_ver_requires_eq() %{nil}
c13be3d1 398%__php_api_requires() %{nil}
7141278d 399%php_major_version ERROR
400%php_api_version ERROR
401%py_ver ERROR
41035426
ER
402%perl_vendorarch ERROR
403%perl_vendorlib ERROR
703ae20b
ER
404# damn. need it here! - copied from /usr/lib/rpm/macros.build
405%tmpdir %(echo "${TMPDIR:-/tmp}")
1f28fcb7
ER
406%patchset_source(f:b:) %(
407 base=%{-b*}%{!-b*:10000};
408 start=$(expr $base + %1);
409 end=$(expr $base + %{?2}%{!?2:%{1}});
410 # we need to call seq twice as it doesn't allow two formats
411 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
412 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
413 paste %{tmpdir}/__ps{1,2};
414 rm -f %{tmpdir}/__ps{1,2};
415) \
416%{nil}
fb198857 417EOF
3d12d055
JR
418 if [ "$NOINIT" = "yes" ] ; then
419 cat >> .builder-rpmmacros <<'EOF'
420%_specdir ./
421%_sourcedir ./
422EOF
c039643c 423 fi
13c3c336 424 eval $RPMBUILD --macros "$safe_macrofiles:.builder-rpmmacros" $QUIET $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $* 2>&1
ace3fd80
ER
425}
426
427cache_rpm_dump() {
428 if [ -n "$DEBUG" ]; then
429 set -x
430 set -v
431 fi
432
433 update_shell_title "cache_rpm_dump"
434 local rpm_dump
435 rpm_dump=`
436 # what we need from dump is NAME, VERSION, RELEASE and PATCHES/SOURCES.
437 dump='%{echo:dummy: PACKAGE_NAME %{name} }%dump'
438 case "$RPMBUILD" in
439 rpm)
440 ARGS='-bp'
441 ;;
442 rpmbuild)
443 ARGS='--nodigest --nosignature --nobuild'
444 ;;
445 esac
446 minirpm $ARGS --define "'prep $dump'" --nodeps $SPECFILE
237bd3f1 447 `
fb198857 448 if [ $? -gt 0 ]; then
237bd3f1
ER
449 error=$(echo "$rpm_dump" | sed -ne '/^error:/,$p')
450 echo "$error" >&2
518ff1fb 451 Exit_error err_build_fail
fb198857 452 fi
d05e8080
ER
453
454 # make small dump cache
455 rpm_dump_cache=`echo "$rpm_dump" | awk '
4e8c3089
ER
456 $2 ~ /^SOURCEURL/ {print}
457 $2 ~ /^PATCHURL/ {print}
458 $2 ~ /^nosource/ {print}
459 $2 ~ /^PACKAGE_/ {print}
d05e8080
ER
460 '`
461
13974367 462 update_shell_title "cache_rpm_dump: OK!"
cd445739
AM
463}
464
ace3fd80 465rpm_dump() {
cd445739 466 if [ -z "$rpm_dump_cache" ] ; then
d7b4d36e 467 echo "internal error: cache_rpm_dump not called! (missing %prep?)" 1>&2
cd445739
AM
468 fi
469 echo "$rpm_dump_cache"
470}
471
d05e8080
ER
472get_icons()
473{
474 update_shell_title "get icons"
475 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
476 if [ -z "$ICONS" ]; then
477 return
478 fi
479
975d7b23 480 rpm_dump_cache="kalasaba" NODIST="yes" get_files $ICONS
d05e8080
ER
481}
482
59398507 483parse_spec()
484{
af4d5315 485 update_shell_title "parsing specfile"
cd445739 486 if [ -n "$DEBUG" ]; then
518ff1fb
ER
487 set -x
488 set -v
cd445739 489 fi
b2975fc3 490
d05e8080 491 # icons are needed for successful spec parse
518ff1fb 492 get_icons
d05e8080 493
cd445739 494 cd $SPECS_DIR
cd445739 495 cache_rpm_dump
00fcec7e 496
cd445739
AM
497 if [ "$NOSRCS" != "yes" ]; then
498 SOURCES="`rpm_dump | awk '/SOURCEURL[0-9]+/ {print $3}'`"
499 fi
7cb24972 500
cd445739
AM
501 if (rpm_dump | grep -qEi ":.*nosource.*1"); then
502 FAIL_IF_NO_SOURCES="no"
503 fi
504
505 PATCHES="`rpm_dump | awk '/PATCHURL[0-9]+/ {print $3}'`"
506 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
dfe2b2d9
ER
507 PACKAGE_NAME=$(rpm_dump | awk '$2 == "PACKAGE_NAME" { print $3; exit}')
508 PACKAGE_VERSION=$(rpm_dump | awk '$2 == "PACKAGE_VERSION" { print $3; exit}')
509 PACKAGE_RELEASE=$(rpm_dump | awk '$2 == "PACKAGE_RELEASE" { print $3; exit}')
78eab2a1 510
cd445739
AM
511 if [ -n "$BE_VERBOSE" ]; then
512 echo "- Sources : `nourl $SOURCES`"
513 if [ -n "$PATCHES" ]; then
514 echo "- Patches : `nourl $PATCHES`"
515 else
516 echo "- Patches : *no patches needed*"
517 fi
518 if [ -n "$ICONS" ]; then
519 echo "- Icon : `nourl $ICONS`"
520 else
521 echo "- Icon : *no package icon*"
522 fi
523 echo "- Name : $PACKAGE_NAME"
524 echo "- Version : $PACKAGE_VERSION"
525 echo "- Release : $PACKAGE_RELEASE"
526 fi
13974367
ER
527
528 update_shell_title "parse_spec: OK!"
cd445739
AM
529}
530
531Exit_error()
532{
533 if [ -n "$DEBUG" ]; then
518ff1fb
ER
534 set -x
535 set -v
cd445739
AM
536 fi
537
538 cd "$__PWD"
539
540 case "$1" in
541 "err_no_spec_in_cmdl" )
542 remove_build_requires
518ff1fb 543 echo "ERROR: spec file name not specified."
cd445739 544 exit 2 ;;
a08d92fc
ER
545 "err_invalid_cmdline" )
546 echo "ERROR: invalid command line arg ($2)."
547 exit 2 ;;
cd445739
AM
548 "err_no_spec_in_repo" )
549 remove_build_requires
518ff1fb 550 echo "Error: spec file not stored in CVS repo."
cd445739
AM
551 exit 3 ;;
552 "err_no_source_in_repo" )
553 remove_build_requires
518ff1fb 554 echo "Error: some source, patch or icon files not stored in CVS repo. ($2)"
cd445739
AM
555 exit 4 ;;
556 "err_build_fail" )
557 remove_build_requires
518ff1fb 558 echo "Error: package build failed. (${2:-no more info})"
cd445739 559 exit 5 ;;
78eab2a1
AM
560 "err_no_package_data" )
561 remove_build_requires
562 echo "Error: couldn't get out package name/version/release from spec file."
563 exit 6 ;;
ce40491a 564 "err_tag_exists" )
50321881 565 remove_build_requires
518ff1fb 566 echo "Tag ${2} already exists (spec release: ${3})."
50321881 567 exit 9 ;;
ce40491a 568 "err_fract_rel" )
50321881 569 remove_build_requires
518ff1fb 570 echo "Release ${2} not integer and not a snapshot."
50321881 571 exit 10 ;;
fb96e0b5
AM
572 "err_branch_exists" )
573 remove_build_requires
518ff1fb 574 echo "Tree branch already exists (${2})."
fb96e0b5 575 exit 11 ;;
cfc497c0
ER
576 "err_acl_deny" )
577 remove_build_requires
578 echo "Error: conditions reject building this spec (${2})."
579 exit 12 ;;
cd445739 580 esac
73848362
ER
581 echo "Unknown error."
582 exit 100
cd445739
AM
583}
584
585init_builder()
586{
587 if [ -n "$DEBUG" ]; then
518ff1fb
ER
588 set -x
589 set -v
0dd6320d 590 fi
cd445739 591
4aeb9973 592 if [ "$NOINIT" != "yes" ] ; then
29e90b02
JR
593 SOURCE_DIR="`eval $RPM $RPMOPTS --eval '%{_sourcedir}'`"
594 SPECS_DIR="`eval $RPM $RPMOPTS --eval '%{_specdir}'`"
595 else
596 SOURCE_DIR="."
597 SPECS_DIR="."
598 fi
cd445739
AM
599
600 __PWD="`pwd`"
00fcec7e 601}
602
d6a77ddb 603get_spec()
1471f6d6 604{
c890b916 605
2e5be021 606 update_shell_title "get_spec"
c890b916 607
cd445739 608 if [ -n "$DEBUG" ]; then
518ff1fb
ER
609 set -x
610 set -v
cd445739
AM
611 fi
612
613 cd "$SPECS_DIR"
049ab214 614 if [ ! -f "$SPECFILE" ]; then
518ff1fb 615 SPECFILE="`basename $SPECFILE .spec`.spec"
cd445739
AM
616 fi
617 if [ "$NOCVSSPEC" != "yes" ]; then
cd445739 618
049ab214
ER
619 if [ ! -s CVS/Root -a "$NOCVSSPEC" != "yes" ]; then
620 echo "Warning: No CVS access defined - using local .spec file"
621 NOCVSSPEC="yes"
cd445739
AM
622 fi
623
049ab214 624 cvsup "$SPECFILE" || Exit_error err_no_spec_in_repo
cd445739 625 fi
049ab214 626
cd445739 627 if [ ! -f "$SPECFILE" ]; then
518ff1fb 628 Exit_error err_no_spec_in_repo
cd445739
AM
629 fi
630
631 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
632 chmod $CHMOD_MODE $SPECFILE
633 fi
634 unset OPTIONS
a7eefc54 635 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $SPECFILE
7e40520f 636
ce40491a 637 set_spec_target
cd445739
AM
638}
639
640find_mirror()
641{
642 cd "$SPECS_DIR"
782518da 643 local url="$1"
cd445739
AM
644 if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
645 cvs update mirrors >&2
646 fi
647
648 IFS="|"
782518da
ER
649 local origin mirror name rest ol prefix
650 while read origin mirror name rest; do
651 # skip comments and empty lines
652 if [ -z "$origin" ] || [[ $origin == \#* ]]; then
653 continue
654 fi
cd445739
AM
655 ol=`echo -n "$origin"|wc -c`
656 prefix="`echo -n "$url" | head -c $ol`"
657 if [ "$prefix" = "$origin" ] ; then
782518da 658 suffix="`echo "$url"|cut -b $((ol+1))-`"
cd445739
AM
659 echo -n "$mirror$suffix"
660 return 0
661 fi
662 done < mirrors
663 echo "$url"
664}
665
e7e0d4ec 666# Warning: unpredictable results if same URL used twice
cd445739
AM
667src_no ()
668{
669 cd $SPECS_DIR
670 rpm_dump | \
671 grep "SOURCEURL[0-9]*[ ]*$1""[ ]*$" | \
672 sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
673 head -n 1 | xargs
1471f6d6 674}
675
e7e0d4ec 676src_md5()
8ba5cdda 677{
e7e0d4ec 678 [ "$NO5" = "yes" ] && return
cd445739
AM
679 no=$(src_no "$1")
680 [ -z "$no" ] && return
681 cd $SPECS_DIR
e7e0d4ec
ER
682 local md5
683
684 if [ -f additional-md5sums ]; then
685 local spec_rev=$(grep $SPECFILE CVS/Entries 2>/dev/null | sed -e s:/$SPECFILE/:: -e s:/.*::)
686 if [ -z "$spec_rev" ]; then
687 spec_rev="$(head -n 1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')"
688 fi
689 local spec="$SPECFILE[0-9.,]*,$(echo $spec_rev | sed 's/\./\\./g')"
690 md5=$(grep -s -v '^#' additional-md5sums | \
691 grep -E "[ ]$(basename "$1")[ ]+${spec}([ ,]|\$)" | \
692 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
693 grep -E '^[0-9a-f]{32}$')
694
695 if [ "$md5" ]; then
696 if [ $(echo "$md5" | wc -l) != 1 ] ; then
697 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
698 fi
699 echo "$md5" | tail -n 1
700 return
701 fi
cd445739 702 fi
e7e0d4ec
ER
703
704 source_md5=`grep -i "#[ ]*Source$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
705 if [ -n "$source_md5" ]; then
706 echo $source_md5
cd445739 707 else
e7e0d4ec
ER
708 # we have empty SourceX-md5, but it is still possible
709 # that we have NoSourceX-md5 AND NoSource: X
710 nosource_md5=`grep -i "#[ ]*NoSource$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
03db3356 711 if [ -n "$nosource_md5" -a -n "`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" ] ; then
e7e0d4ec 712 echo $nosource_md5
cd445739 713 fi
cd445739
AM
714 fi
715}
716
06541433
JR
717distfiles_path ()
718{
719 echo "by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
720}
721
cd445739
AM
722distfiles_url ()
723{
06541433 724 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/$(distfiles_path "$1")"
cd445739
AM
725}
726
727distfiles_attic_url ()
728{
06541433 729 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/$(distfiles_path "$1")"
cd445739
AM
730}
731
732good_md5 ()
733{
734 md5=$(src_md5 "$1")
735 [ "$md5" = "" ] || \
736 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
8ba5cdda
PG
737}
738
a4b50627
AF
739good_size ()
740{
ce40491a
ER
741 size="$(find $(nourl "$1") -printf "%s" 2>/dev/null)"
742 [ -n "$size" -a "$size" -gt 0 ]
a4b50627
AF
743}
744
947025e5 745cvsignore_df ()
746{
747 if [ "$CVSIGNORE_DF" != "yes" ]; then
748 return
749 fi
750 cvsignore=${SOURCE_DIR}/.cvsignore
751 if ! grep -q "^$1\$" $cvsignore 2> /dev/null; then
752 echo "$1" >> $cvsignore
753 fi
754}
755
e7fa3b9f
ER
756cvsup()
757{
ce40491a
ER
758 update_shell_title "cvsup"
759 local OPTIONS="up "
760 if [ -n "$CVSROOT" ]; then
761 OPTIONS="-d $CVSROOT $OPTIONS"
762 fi
b1c6aace 763
ce40491a
ER
764 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
765 OPTIONS="$OPTIONS -A"
766 else
767 if [ -n "$CVSDATE" ]; then
768 OPTIONS="$OPTIONS -D $CVSDATE"
769 fi
770 if [ -n "$CVSTAG" ]; then
771 OPTIONS="$OPTIONS -r $CVSTAG"
772 fi
773 fi
e7fa3b9f 774
ce40491a
ER
775 local result=1
776 local retries_counter=0
777 if [ $# = 1 ]; then
778 update_shell_title "cvsup: $*"
779 else
780 update_shell_title "cvsup: $# files"
781 fi
782 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; do
783 retries_counter=$(( $retries_counter + 1 ))
784 output=$(LC_ALL=C cvs $OPTIONS "$@" 2>&1)
785 result=$?
786 [ -n "$output" ] && echo "$output"
787 if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
788 echo "Trying again [$*]... ($retries_counter)"
789 update_shell_title "cvsup: retry #$retries_counter"
790 sleep 2
791 continue
792 else
793 break
794 fi
795 done
796 update_shell_title "cvsup: done!"
797 return $result
e7fa3b9f
ER
798}
799
71f8e908
ER
800# returns true if "$1" is ftp, http or https protocol url
801is_url()
802{
803 case "$1" in
804 ftp://*|http://*|https://*)
805 return 0
806 ;;
807 esac
808 return 1
809}
810
ecba6ad5
ER
811update_md5()
812{
813 if [ $# -eq 0 ]; then
814 return
815 fi
816
817 update_shell_title "update md5"
818 if [ -n "$DEBUG" ]; then
518ff1fb
ER
819 set -x
820 set -v
ecba6ad5
ER
821 fi
822
823 cd "$SOURCE_DIR"
824
825 # pass 1: check files to be fetched
826 local todo
827 local need_files
828 for i in "$@"; do
829 local fp=$(nourl "$i")
830 local srcno=$(src_no "$i")
6392b5fd
ER
831 if [ -n "$ADD5" ]; then
832 [ "$fp" = "$i" ] && continue # FIXME what is this check doing?
833 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE && continue
834 else
835 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE || continue
ecba6ad5
ER
836 fi
837 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
838 need_files="$need_files $i"
839 fi
840 done
841
842 # pass 1a: get needed files
843 if [ "$need_files" ]; then
844 get_files $need_files
845 fi
846
847 # pass 2: proceed with md5 adding or updating
848 for i in "$@"; do
849 local fp=$(nourl "$i")
850 local srcno=$(src_no "$i")
71f8e908
ER
851 local md5=$(grep -iE '^#[ ]*(No)?Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE )
852 if [ -n "$ADD5" ] && is_url $i || [ -n "$md5" ]; then
853 local tag="Source$srcno-md5"
854 if [[ "$md5" == *NoSource* ]]; then
855 tag="NoSource$srcno-md5"
856 fi
ecba6ad5 857 md5=$(md5sum "$fp" | cut -f1 -d' ')
4efa0b98 858 echo "Updating $tag ($md5: $fp)."
ecba6ad5 859 perl -i -ne '
71f8e908
ER
860 print unless /^\s*#\s*(No)?Source'$srcno'-md5\s*:/i;
861 print "# '$tag':\t'$md5'\n" if /^Source'$srcno'\s*:\s+/;
ecba6ad5
ER
862 ' \
863 $SPECS_DIR/$SPECFILE
864 fi
865 done
866}
867
868check_md5()
869{
870 update_shell_title "check md5"
871
872 for i in "$@"; do
873 if good_md5 "$i" && good_size "$i"; then
874 continue
875 fi
876
877 echo "MD5 sum mismatch or 0 size. Use -U to refetch sources,"
878 echo "or -5 to update md5 sums, if you're sure files are correct."
879 Exit_error err_no_source_in_repo $i
880 done
881}
882
cd445739
AM
883get_files()
884{
7cb24972 885 update_shell_title "get_files"
cd445739
AM
886
887 if [ -n "$DEBUG" ]; then
518ff1fb
ER
888 set -x
889 set -v
cd445739
AM
890 fi
891
f09c0772 892 if [ $# -gt 0 ]; then
cd445739
AM
893 cd "$SOURCE_DIR"
894
b1c6aace 895 if [ ! -s CVS/Root -a "$NOCVS" != "yes" ]; then
049ab214 896 echo "Warning: No CVS access defined for SOURCES"
b1c6aace
ER
897 NOCVS="yes"
898 fi
899
f2e42a41 900 local nc=0
e7fa3b9f 901 local get_files_cvs=""
3815b69a 902 for i in "$@"; do
f2e42a41 903 nc=$((nc + 1))
dcebdffb 904 local cvsup=0
3815b69a 905 SHELL_TITLE_PREFIX="get_files[$nc/$#]"
f2e42a41 906 update_shell_title "$i"
f09c0772 907 local fp=`nourl "$i"`
ecba6ad5 908 if [ "$SKIP_EXISTING_FILES" = "yes" ] && [ -f "$fp" ]; then
ce40491a 909 continue
18e5347d 910 fi
ecba6ad5 911
cd445739 912 FROM_DISTFILES=0
e7e0d4ec 913 local srcmd5=$(src_md5 "$i")
ecba6ad5
ER
914
915 # we know if source/patch is present in cvs/distfiles
916 # - has md5 (in distfiles)
917 # - in cvs... ideas?
918
919 # CHECK: local file didn't exist or always cvs up (first) requested.
f09c0772 920 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
cd445739
AM
921 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
922 echo "Warning: no URL given for $i"
923 fi
924
e7e0d4ec 925 if [ -z "$NODIST" ] && [ -n "$srcmd5" ]; then
a4b50627 926 if good_md5 "$i" && good_size "$i"; then
e7e0d4ec 927 echo "$fp having proper md5sum already exists"
cd445739
AM
928 continue
929 fi
4ea1c265 930 target="$fp"
28b34560
ER
931
932 # prefer mirror over distfiles if there's mirror
933 # TODO: build url list and then try each url from the list
934 if [ -z "$NOMIRRORS" ] && im=$(find_mirror "$i") && [ "$im" != "$i" ]; then
935 url="$im"
936 else
937 url=$(distfiles_url "$i")
938 fi
939
cd445739
AM
940 url_attic=$(distfiles_attic_url "$i")
941 FROM_DISTFILES=1
ecba6ad5
ER
942 # is $url local file?
943 if [[ "$url" = [./]* ]]; then
18a52930 944 update_shell_title "${GETLOCAL%% *}: $url"
cd445739
AM
945 ${GETLOCAL} $url $target
946 else
947 if [ -z "$NOMIRRORS" ]; then
9e9f8920 948 url=$(find_mirror "$url")
cd445739 949 fi
9e9f8920
ER
950
951 local uri=${url}
952 # make shorter message for distfiles urls
953 if [[ "$uri" = ${PROTOCOL}${DISTFILES_SERVER}* ]] || [[ "$uri" = ${PROTOCOL}${ATTICDISTFILES_SERVER}* ]]; then
954 uri=${uri#${PROTOCOL}${DISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
955 uri=${uri#${PROTOCOL}${ATTICDISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
956 uri="df: $uri"
957 fi
958 update_shell_title "${GETURI%% *}: $uri"
ca2e6c31 959 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 960 if [ "`echo $url | grep -E 'ftp://'`" ]; then
18a52930 961 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 962 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
963 fi
964 fi
ecba6ad5
ER
965
966 # is it empty file?
967 if [ ! -s "$target" ]; then
cd445739
AM
968 rm -f "$target"
969 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
18a52930 970 update_shell_title "${GETLOCAL%% *}: $url_attic"
cd445739
AM
971 ${GETLOCAL} $url_attic $target
972 else
973 if [ -z "$NOMIRRORS" ]; then
974 url_attic="`find_mirror "$url_attic"`"
975 fi
18a52930 976 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 977 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 978 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 979 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 980 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
981 fi
982 fi
983 fi
ecba6ad5
ER
984
985 if [ -s "$target" ]; then
947025e5 986 cvsignore_df $target
987 else
cd445739
AM
988 rm -f "$target"
989 FROM_DISTFILES=0
990 fi
e7e0d4ec 991 elif [ "$NOCVS" != "yes" -a -z "$srcmd5" ]; then
d05e8080
ER
992 if [ $# -gt 1 ]; then
993 get_files_cvs="$get_files_cvs $fp"
994 update_shell_title "$fp (will cvs up later)"
995 cvsup=1
996 else
997 cvsup $fp
998 fi
cd445739
AM
999 fi
1000
f09c0772 1001 if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
cd445739
AM
1002 if [ -z "$NOMIRRORS" ]; then
1003 im="`find_mirror "$i"`"
1004 else
1005 im="$i"
1006 fi
ce40491a 1007 update_shell_title "${GETURI%% *}: $im"
cd445739 1008 ${GETURI} "$im" || \
33da77c4 1009 if [ "`echo $im | grep -E 'ftp://'`" ]; then
ce40491a 1010 update_shell_title "${GETURI2%% *}: $im"
cd445739 1011 ${GETURI2} "$im"
7e365483 1012 fi
cd445739
AM
1013 fi
1014
dcebdffb
ER
1015 if [ "$cvsup" = 1 ]; then
1016 continue
1017 fi
1018
cd445739 1019 fi
ecba6ad5
ER
1020
1021 # the md5 check must be moved elsewhere as if we've called from update_md5 the md5 is wrong.
f09c0772 1022 if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
518ff1fb 1023 Exit_error err_no_source_in_repo $i
cd445739 1024 fi
2a5f078d 1025
ecba6ad5 1026 # we check md5 here just only to refetch immediately
a4b50627 1027 if good_md5 "$i" && good_size "$i"; then
cd445739
AM
1028 :
1029 elif [ "$FROM_DISTFILES" = 1 ]; then
deccc50e 1030 # wrong md5 from distfiles: remove the file and try again
cd445739 1031 # but only once ...
deccc50e 1032 echo "MD5 sum mismatch. Trying full fetch."
cd445739
AM
1033 FROM_DISTFILES=2
1034 rm -f $target
18a52930 1035 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 1036 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 1037 if [ "`echo $url | grep -E 'ftp://'`" ]; then
ce40491a 1038 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 1039 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739 1040 fi
ecba6ad5 1041 if [ ! -s "$target" ]; then
cd445739 1042 rm -f "$target"
18a52930 1043 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 1044 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 1045 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 1046 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 1047 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
1048 fi
1049 fi
1050 test -s "$target" || rm -f "$target"
1051 fi
cd445739 1052 done
e7fa3b9f
ER
1053 SHELL_TITLE_PREFIX=""
1054
1055 if [ "$get_files_cvs" ]; then
ce40491a 1056 cvsup $get_files_cvs
e7fa3b9f 1057 fi
cd445739
AM
1058
1059 if [ "$CHMOD" = "yes" ]; then
3815b69a 1060 CHMOD_FILES="`nourl "$@"`"
cd445739
AM
1061 if [ -n "$CHMOD_FILES" ]; then
1062 chmod $CHMOD_MODE $CHMOD_FILES
1063 fi
1064 fi
cd445739
AM
1065 fi
1066}
1067
1068make_tagver() {
ce40491a 1069 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1070 set -x
1071 set -v
ce40491a 1072 fi
78eab2a1 1073
ce40491a
ER
1074 # Check whether first character of PACKAGE_NAME is legal for tag name
1075 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
1076 TAG_PREFIX=tag_
1077 fi
d712cc12
ER
1078
1079 # NOTE: CVS tags may must not contain the characters `$,.:;@'
392187d9 1080 TAGVER=$(echo $TAG_PREFIX$PACKAGE_NAME-$PACKAGE_VERSION-$PACKAGE_RELEASE | tr '[.@]' '[_#]')
d712cc12 1081
ce40491a
ER
1082 # Remove #kernel.version_release from TAGVER because tagging sources
1083 # could occur with different kernel-headers than kernel-headers used at build time.
d712cc12
ER
1084 # besides, %{_kernel_ver_str} is not expanded.
1085
1086 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1#%{_kernel_ver_str}
1087 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1
1088
1089 TAGVER=${TAGVER%#*}
ce40491a 1090 echo -n "$TAGVER"
cd445739
AM
1091}
1092
1093tag_files()
1094{
1095 TAG_FILES="$@"
1096
1097 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1098 set -x
1099 set -v
cd445739
AM
1100 fi
1101
73ef63d8
ER
1102 echo "Version: $PACKAGE_VERSION"
1103 echo "Release: $PACKAGE_RELEASE"
cd445739 1104
a18a9761 1105 local TAGVER
73ef63d8 1106 if [ "$TAG_VERSION" = "yes" ]; then
a18a9761 1107 TAGVER=`make_tagver`
73ef63d8
ER
1108 echo "CVS tag: $TAGVER"
1109 fi
1110 if [ -n "$TAG" ]; then
1111 echo "CVS tag: $TAG"
1112 fi
cd445739 1113
39dcc7de 1114 local OPTIONS="tag $CVS_FORCE"
73ef63d8
ER
1115 if [ -n "$CVSROOT" ]; then
1116 OPTIONS="-d $CVSROOT $OPTIONS"
1117 fi
cd445739 1118
73ef63d8
ER
1119 cd "$SOURCE_DIR"
1120 local tag_files
1121 for i in $TAG_FILES; do
1122 # don't tag files stored on distfiles
1123 [ -n "`src_md5 $i`" ] && continue
1124 local fp=`nourl "$i"`
1125 if [ -f "$fp" ]; then
1126 tag_files="$tag_files $fp"
1127 else
1128 Exit_error err_no_source_in_repo $i
03db3356 1129 fi
73ef63d8 1130 done
03db3356 1131
73ef63d8 1132 if [ "$tag_files" ]; then
cd445739 1133 if [ "$TAG_VERSION" = "yes" ]; then
73ef63d8 1134 update_shell_title "tag sources: $TAGVER"
c7e6ee9b 1135 cvs $OPTIONS $TAGVER $tag_files || exit
cd445739
AM
1136 fi
1137 if [ -n "$TAG" ]; then
73ef63d8 1138 update_shell_title "tag sources: $TAG"
c7e6ee9b 1139 cvs $OPTIONS $TAG $tag_files || exit
cd445739 1140 fi
73ef63d8
ER
1141 fi
1142
1143 cd "$SPECS_DIR"
1144 if [ "$TAG_VERSION" = "yes" ]; then
1145 update_shell_title "tag spec: $TAGVER"
c7e6ee9b 1146 cvs $OPTIONS $TAGVER $SPECFILE || exit
73ef63d8
ER
1147 fi
1148 if [ -n "$TAG" ]; then
1149 update_shell_title "tag spec: $TAG"
c7e6ee9b 1150 cvs $OPTIONS $TAG $SPECFILE || exit
73ef63d8 1151 fi
cd445739
AM
1152}
1153
1154branch_files()
1155{
1156 TAG=$1
1157 echo "CVS branch tag: $TAG"
518ff1fb 1158 shift
cd445739
AM
1159
1160 TAG_FILES="$@"
1161
1162 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1163 set -x
1164 set -v
cd445739
AM
1165 fi
1166
78a5a506
ER
1167 local OPTIONS="tag $CVS_FORCE -b"
1168 if [ -n "$CVSROOT" ]; then
1169 OPTIONS="-d $CVSROOT $OPTIONS"
1170 fi
1171 cd "$SOURCE_DIR"
1172 local tag_files
1173 for i in $TAG_FILES; do
1174 local fp=`nourl "$i"`
1175 if [ -f "$fp" ]; then
1176 tag_files="$tag_files $fp"
1177 else
1178 Exit_error err_no_source_in_repo $i
c10fa4fa 1179 fi
78a5a506
ER
1180 done
1181 if [ "$tag_files" ]; then
c7e6ee9b 1182 cvs $OPTIONS $TAG $tag_files || exit
78a5a506 1183 fi
c10fa4fa 1184
78a5a506 1185 cd "$SPECS_DIR"
c7e6ee9b 1186 cvs $OPTIONS $TAG $SPECFILE || exit
cd445739
AM
1187}
1188
1189
3009b80d
ER
1190# this function should exit early if package can't be built for this arch
1191# this avoids unneccessary BR filling.
1192check_buildarch() {
1193 local out ret
13c3c336 1194 out=$(minirpm --short-circuit -bp --define "'prep exit 0'" --nodeps $SPECFILE 2>&1)
3009b80d
ER
1195 ret=$?
1196 if [ $ret -ne 0 ]; then
1197 echo >&2 "$out"
1198 exit $ret
1199 fi
1200}
1201
cd445739 1202
59398507 1203build_package()
1204{
2e5be021 1205 update_shell_title "build_package"
cd445739 1206 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1207 set -x
1208 set -v
cd445739 1209 fi
5a491465 1210
cd445739
AM
1211 cd "$SPECS_DIR"
1212
1213 if [ -n "$TRY_UPGRADE" ]; then
ce40491a 1214 update_shell_title "build_package: try_upgrade"
cd445739 1215 if [ -n "$FLOAT_VERSION" ]; then
cc538c24 1216 TNOTIFY=`./pldnotify.awk $SPECFILE -n` || exit 1
cd445739 1217 else
cc538c24 1218 TNOTIFY=`./pldnotify.awk $SPECFILE` || exit 1
cd445739
AM
1219 fi
1220
1221 TNEWVER=`echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }'`
1222
1223 if [ -n "$TNEWVER" ]; then
1224 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
1225 echo "New version found, updating spec file to version " $TNEWVER
257af81b
ER
1226 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1227 cp -f $SPECFILE $SPECFILE.bak
1228 fi
cd445739
AM
1229 chmod +w $SPECFILE
1230 eval "perl -pi -e 's/Version:\t"$TOLDVER"/Version:\t"$TNEWVER"/gs' $SPECFILE"
f7b91886 1231 eval "perl -pi -e 's/Release:\t[1-9]{0,4}/Release:\t0.1/' $SPECFILE"
518ff1fb
ER
1232 parse_spec
1233 NODIST="yes" get_files $SOURCES $PATCHES
6392b5fd 1234 update_md5 $SOURCES
975d7b23 1235
cd445739
AM
1236 unset TOLDVER TNEWVER TNOTIFY
1237 fi
1238 fi
1239 cd "$SPECS_DIR"
2a5f078d 1240
cd445739
AM
1241 case "$COMMAND" in
1242 build )
1243 BUILD_SWITCH="-ba" ;;
1244 build-binary )
1245 BUILD_SWITCH="-bb" ;;
1246 build-source )
1247 BUILD_SWITCH="-bs --nodeps" ;;
1248 build-prep )
1249 BUILD_SWITCH="-bp --nodeps" ;;
6594293d
AG
1250 build-build )
1251 BUILD_SWITCH="-bc" ;;
1252 build-install )
1253 BUILD_SWITCH="-bi" ;;
1254 build-list )
1255 BUILD_SWITCH="-bl" ;;
1256
cd445739 1257 esac
c890b916 1258
2e5be021 1259 update_shell_title "build_package: $COMMAND"
cd445739
AM
1260 if [ -n "$LOGFILE" ]; then
1261 LOG=`eval echo $LOGFILE`
1262 if [ -d "$LOG" ]; then
1263 echo "Log file $LOG is a directory."
1264 echo "Parse error in the spec?"
518ff1fb 1265 Exit_error err_build_fail
cd445739
AM
1266 fi
1267 if [ -n "$LASTLOG_FILE" ]; then
1268 echo "LASTLOG=$LOG" > $LASTLOG_FILE
1269 fi
1270 RES_FILE=~/tmp/$RPMBUILD-exit-status.$RANDOM
86aafdbe 1271 (time eval ${NICE_COMMAND} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
cd445739
AM
1272 RETVAL=`cat $RES_FILE`
1273 rm $RES_FILE
1274 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
1275 if [ "$RETVAL" -eq "0" ]; then
1276 mv $LOG $LOGDIROK
1277 else
1278 mv $LOG $LOGDIRFAIL
1279 fi
1280 fi
8ba5cdda 1281 else
86aafdbe 1282 eval ${NICE_COMMAND} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $SPECFILE
cd445739 1283 RETVAL=$?
8ba5cdda 1284 fi
cd445739
AM
1285 if [ "$RETVAL" -ne "0" ]; then
1286 if [ -n "$TRY_UPGRADE" ]; then
796a8a95 1287 echo "\n!!! Package with new version cannot be built automagically\n"
257af81b
ER
1288 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1289 mv -f $SPECFILE.bak $SPECFILE
1290 fi
cd445739 1291 fi
518ff1fb 1292 Exit_error err_build_fail
cd445739
AM
1293 fi
1294 unset BUILD_SWITCH
1295}
1296
1297nourl()
1298{
1299 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1300}
1301
cd445739
AM
1302install_required_packages()
1303{
1304 run_poldek -vi $1
1305 return $?
1306}
1307
fa4bf1df
ER
1308find_spec_bcond() {
1309 # taken from find-spec-bcond, but with just getting the list
1310 local SPEC="$1"
1311 # quick revert hint: '$RPMBUILD --bcond $SPEC'
1312 awk -F"\n" '
1313 /^%changelog/ { exit }
1314 /_with(out)?_[_a-zA-Z0-9]+/{
1315 match($0, /_with(out)?_[_a-zA-Z0-9]+/);
1316 print substr($0, RSTART, RLENGTH);
1317 }
1318 /^%bcond_with/{
1319 match($0, /bcond_with(out)?[ \t]+[_a-zA-Z0-9]+/);
1320 bcond = substr($0, RSTART +5 , RLENGTH -5);
1321 gsub(/[ \t]+/,"_",bcond);
1322 print bcond
1323 }' $SPEC | LC_ALL=C sort -u
1324}
1325
117d9861 1326process_bcondrc() {
301cbfd4
ER
1327 # expand bconds from ~/.bcondrc
1328 # The file structure is like gentoo's package.use:
1329 # ---
1330 # * -selinux
1331 # samba -mysql -pgsql
47a8df12 1332 # w32codec-installer license_agreement
301cbfd4
ER
1333 # php +mysqli
1334 # ---
fa4bf1df 1335 if ([ -f $HOME/.bcondrc ] || ([ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ])); then
117d9861
ER
1336 :
1337 else
1338 return
1339 fi
301cbfd4 1340
117d9861 1341 SN=${SPECFILE%%\.spec}
c8a3e2ac 1342
117d9861
ER
1343 local bcondrc=$HOME/.bcondrc
1344 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && bcondrc=$HOME_ETC/.bcondrc
301cbfd4 1345
117d9861 1346 local bcond_avail=$(find_spec_bcond $SPECFILE)
301cbfd4 1347
117d9861
ER
1348 while read pkg flags; do
1349 # ignore comments
1350 [[ "$pkg" == \#* ]] && continue
1351
1352 # any package or current package?
1353 if [ "$pkg" = "*" ] || [ "$pkg" = "$PACKAGE_NAME" ] || [ "$pkg" = "$SN" ]; then
1354 for flag in $flags; do
1355 local opt=${flag#[+-]}
1356
1357 # use only flags which are in this package.
1358 if [[ $bcond_avail = *${opt}* ]]; then
1359 if [[ $flag = -* ]]; then
1360 if [[ $BCOND != *--with?${opt}* ]]; then
1361 BCOND="$BCOND --without $opt"
1362 fi
1363 else
1364 if [[ $BCOND != *--without?${opt}* ]]; then
1365 BCOND="$BCOND --with $opt"
301cbfd4
ER
1366 fi
1367 fi
117d9861
ER
1368 fi
1369 done
1370 fi
1371 done < $bcondrc
1372 update_shell_title "parse ~/.bcondrc: DONE!"
1373}
1374
1375set_bconds_values()
1376{
1377 update_shell_title "set bcond values"
1378
1379 AVAIL_BCONDS_WITHOUT=""
1380 AVAIL_BCONDS_WITH=""
1381 if `grep -q ^%bcond ${SPECFILE}`; then
1382 BCOND_VERSION="NEW"
1383 elif `egrep -q ^#\ *_with ${SPECFILE}`; then
1384 BCOND_VERSION="OLD"
1385 else
1386 return
301cbfd4
ER
1387 fi
1388
117d9861
ER
1389 local bcond_avail=$(find_spec_bcond $SPECFILE)
1390 process_bcondrc "$SPECFILE"
1391
fa4bf1df 1392 update_shell_title "parse bconds"
cd445739 1393 case "${BCOND_VERSION}" in
fa4bf1df 1394 NONE)
7e365483 1395 :
cd445739 1396 ;;
7e365483 1397 OLD)
cd445739 1398 echo "Warning: This spec has old style bconds. Fix it || die."
fa4bf1df 1399 for opt in `echo "$bcond_avail" | grep ^_without_`
cd445739 1400 do
fa4bf1df
ER
1401 AVAIL_BCOND_WITHOUT=${opt#_without_}
1402 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
cd445739
AM
1403 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1404 else
1405 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1406 fi
1407 done
2a5f078d 1408
fa4bf1df 1409 for opt in `echo "$bcond_avail" | grep ^_with_`
cd445739 1410 do
fa4bf1df
ER
1411 AVAIL_BCOND_WITH=${opt#_with_}
1412 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
cd445739
AM
1413 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1414 else
1415 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1416 fi
1417 done
1418 ;;
1419 NEW)
fa4bf1df
ER
1420 local cond_type="" # with || without
1421 for opt in $bcond_avail; do
cd445739
AM
1422 case "$opt" in
1423 _without)
1424 cond_type="without"
1425 ;;
1426 _with)
1427 cond_type="with"
1428 ;;
f8d24cee 1429 _without_*)
fa4bf1df
ER
1430 AVAIL_BCOND_WITHOUT=${opt#_without_}
1431 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
f8d24cee 1432 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1433 else
1434 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1435 fi
1436 ;;
1437 _with_*)
fa4bf1df
ER
1438 AVAIL_BCOND_WITH=${opt#_with_}
1439 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
f8d24cee 1440 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1441 else
1442 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1443 fi
1444 ;;
cd445739
AM
1445 *)
1446 case "$cond_type" in
1447 with)
1448 cond_type=''
1449 AVAIL_BCOND_WITH="$opt"
fa4bf1df 1450 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
cd445739
AM
1451 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1452 else
1453 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1454 fi
7e365483 1455 ;;
cd445739
AM
1456 without)
1457 cond_type=''
1458 AVAIL_BCOND_WITHOUT="$opt"
fa4bf1df 1459 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
cd445739
AM
1460 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1461 else
1462 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1463 fi
1464 ;;
1465 esac
1466 ;;
1467 esac
1468 done
1469 ;;
1470 esac
1471}
1472
1473run_sub_builder()
1474{
1475 package_name="${1}"
af6b168f 1476 update_shell_title "run_sub_builder $package_name"
cd445739
AM
1477 #
1478